
local CO = require "api_coservice"
local MSG = require "api_msg"
local cjson = require "cjson"

local dset = {}



local upload = require "resty.upload"
local STORE_PATH="/tmp/.web_upload/"
os.execute( "/bin/mkdir -p " .. STORE_PATH )



local function checkPartType(res)
	if type(res) == "table" then
		local idr = res[1]:lower()
		if idr == "content-disposition" then
			local fieldname, filename = res[2]:match('name=%"(.*)%".*filename=%"(.*)%"')
			if not fieldname then
				fieldname = res[2]:match('name=%"(.*)%"')
			end
			if not fieldname then
				return nil
			end
			if not filename then
				return "field", fieldname
			else
				return "file", fieldname, filename
			end
		elseif idr == "content-type" then
			return idr, res[2] or ""
		else
			return nil
		end
	else
		return nil
	end
end

local function getUploadFile(args)
	args = args or {}
	local form,err = upload:new(8192)
	if not form then
		return nil,nil, "无法开启上传文件:" .. (err or "")
	end
	form:set_timeout(5*1000)        --5secs timeout

	local fieldType, fieldName
	local srcFileName 
	local curFile

	while true do

		local typ, res, err = form:read()
		if not typ then
			if curFile then
				curFile:close()
			end
			return nil,nil, "formreadError"
		end

		if typ == "header" then
			local ftype,fname,filename = checkPartType(res)
			if ftype == "field" then
				fieldType = ftype
				fieldName = fname
				args[fieldName] = ""
			elseif ftype == "file" then
				fieldType = ftype
				fieldName = fname
				srcFileName = filename
				if srcFileName == "" then
					return nil,nil, "InvalidFileError"
				end
			elseif ftype == "content-type" then
				if fieldType ~= "file" then
					if curFile then
						curFile:close()
					end
					return nil,nil, "InvalidContentType"
				elseif fname ~= "image/jpeg" and fname ~="image/png" and fname ~="image/jpg" then
				-- elseif  fname ~="image/png"  then

					if curFile then
						curFile:close()
					end
					-- return nil, "上传文件必须是png文件"
					return nil,nil, "fileTypeError"
				else
					local openerrormsg
					-- curFile, openerrormsg = io.open( STORE_PATH  .. "logo.png", "wb" )
					STORE_PATH="/tmp/.web_upload/"
					ngx.log(ngx.ALERT, "-重置---STORE_PATH-------",STORE_PATH.. srcFileName)

					curFile, openerrormsg = io.open( STORE_PATH  .. srcFileName, "wb" )
					if not curFile then
						return nil,nil, "createUploadError"
					end
					
				end
			else
				filedType = nil
				fieldName = nil
				if curFile then
					curFile:close()
					curFile = nil
				end
			end
		elseif typ == "body" then
			if fieldType == "field" then
				args[fieldName] = args[fieldName] .. res
			elseif fieldType == "file" then
				if not curFile then
					return nil,nil, "uploadError"
				end
				curFile:write( res )
			end
		elseif typ == "part_end" then
			filedType = nil
			fieldName = nil
			if curFile then
				curFile:close()
				curFile = nil
			end
		elseif typ == "eof" then
			break
		end
	end

	if curFile then
		curFile:close()
	end

	if not srcFileName then
		return nil,nil, "noFileError"
	end
	local image_name = args["name"]

	-- local file_,file_type = string.match(srcFileName,"(%a+).(%a+)")
	-- ngx.log(ngx.ALERT, "-string.match-------",file_,file_type)
	-- ngx.log(ngx.ALERT, "-old file-------",srcFileName)

	local num1,num2 = string.find(srcFileName,"%.")
	local file_type = string.sub(srcFileName,num1,-1)
	-- ngx.log(ngx.ALERT, "-new file-------",random_num .. time_name  .. file_type)
	-- os.execute("cp -rf \"" .. STORE_PATH .. srcFileName .. "\"  /data/upload_image/".. image_name  .. file_type) -- api层不能复制到data目录
	return STORE_PATH .. srcFileName,image_name .. file_type
end


--上传图片
local function API_upgrade(red, args)
	--TODO:上传4K文件导致proxy连接不上
	local local_cmd,srcFileName, err = getUploadFile(args)
	if not srcFileName or not local_cmd then
		return false, err or "文件上传错误"
	end
	--todo 将上传成功的图片 保存到数据库
	local tabs={}
	tabs.local_cmd = local_cmd
	tabs.url = srcFileName
	tabs.name = args.name
	tabs.size_w = args.size_w
	tabs.size_h = args.size_h
    local proxy = CO.GetProxy( "/", "img_manager","local", 10 )
	if proxy then
		local r, done, err = proxy.AddPic(tabs)
		proxy:Destroy()
		if r and done then
			proxy = CO.GetProxy( "/", "codec" )
			if proxy then
				proxy.ReloadImg()
				proxy:Destroy()
			end
			MSG.OK()
			return true
		else
			MSG.ERROR("add error")
			return true
		end
	else
		MSG.ERROR("picManagerError")
		return true
	end
	return true
end


local function API_get(red, args)
    --查询分为  
    --type=all,查询所有图片
    --type=osd，
	--type=bg，--output

	local proxy = CO.GetProxy( "/", "img_manager" )
	if proxy then

		-- local r, done = proxy.GetPics(type,args.output)
		local r, done
		r, done = proxy.GetPics()

		proxy:Destroy()
		if r and done then
			MSG.OK("",{data=done})
			return true
		else
			MSG.ERROR("searchPicError")
			return true
		end
	else
		MSG.ERROR( "picManagerError" )
		return true
	end

    return true
end


local function API_resetPic(red, args)
    --查询分为  
    --type=all,查询所有图片
    --type=osd，
	--type=bg，--output

	local proxy = CO.GetProxy( "/", "img_manager","local", 10 )
	if proxy then

		-- local r, done = proxy.GetPics(type,args.output)
		local r, done
		r, done = proxy.ResetPic(args.name)

		proxy:Destroy()
		if r and done then
			proxy = CO.GetProxy( "/", "codec" )
			if proxy then
				proxy.ReloadImg()
				proxy:Destroy()
			end
			MSG.OK("")
			return true
		else
			MSG.ERROR("resetPicError")
			return true
		end
	else
		MSG.ERROR( "picManagerError" )
		return true
	end

    return true
end

-----------------------------
dset.APIS = dset.APIS or {}

dset.APIS["get"] = API_get
dset.APIS["add"] = API_upgrade
dset.APIS["resetPic"] = API_resetPic


--------------------------------------
return dset
