local DC = require "supertable.declare"
local CONF = require "supertable.core"

local _M = {
	config_file = "/data/configs/pic.conf"
}

--------------------------------------------

local img_template = DC.OBJ({

    NOSIGNAL = DC.OBJ({
        size_h = DC.INT(1080),
        size_w = DC.INT(1920),
        id = DC.INT(1),
        url = DC.STR("NOSIGNAL.png"),
        content = DC.STR("NO INPUT SIGNAL")
	}),
    SPLASH = DC.OBJ({
        size_h = DC.INT(1080),
        size_w = DC.INT(1920),
        id = DC.INT(2),
        url = DC.STR("SPLASH.png"),
        content = DC.STR("DECODING MODE")
	}),
    UNSUPPORT_CODEC = DC.OBJ({
        size_h = DC.INT(1080),
        size_w = DC.INT(1920),
        id = DC.INT(3),
        url = DC.STR("UNSUPPORT_CODEC.png"),
        content = DC.STR("UNSUPPORT CODEC")
	}),
    UNSUPPORT = DC.OBJ({
        size_h = DC.INT(1080),
        size_w = DC.INT(1920),
        id = DC.INT(4),
        url = DC.STR("UNSUPPORT.png"),
        content = DC.STR("UNSUPPORT RESOLUTION")
	}),

}) : __changed( function(conf)
	conf:TAB_SAVE()
end)

--------------------------------------------

function _M.Load()
	local conf = CONF.Create({}, img_template)
	conf:TAB_STORAGE( "file", { file = _M.config_file } )
	conf:TAB_LOAD()
	conf:TAB_RESET_CHANGE()
	return conf
end

--------------------------------------------

return _M


