local coaf = require "coaf.core"
local _dbg = require "coaf.debug"
local periphery = require( "periphery" )
-----------------------------------
_M = {
	HardwareVersion = nil
}

function _M.GetHardwareVersion()
	--TODO: Detect hardware version.
	if _M.HardwareVersion then
		return _M.HardwareVersion
	end

	local success_gpio956,gpio956 = pcall(periphery.GPIO,956,"in")
	local success_gpio957,gpio957 = pcall(periphery.GPIO,957,"in")

	if success_gpio956 and success_gpio957 then
		local x,y
		x = gpio956:read()
		y = gpio957:read()
		if not x and not y then
			_M.HardwareVersion = "1.1"
		elseif not x and y then
			_M.HardwareVersion = "2.0"
		elseif x and not y then
			_M.HardwareVersion = "3.0"
		else
			_M.HardwareVersion = "4.0"
		end
	else
		_M.HardwareVersion = "1.1"
	end
	return _M.HardwareVersion
end

-----------------------------------

return _M


