--Requirements for upgrading
local BASED_VERSION_NUM='0000'
local NEW_VERSION_NUM='0227'
local NEW_VERSION='2.02.0227'
local ROOT_REQ_SPACES=16192  --KB
local DATA_REQ_SPACES=10720  --KB
local BASED_DEVICE_TYPE='GO_SDI'
local BASED_PRODUCT_ID='N3-s'
local IS_DOWNGRADE=false
---- Up before this are arguments auto generated by upgrading scripts ---
local function UpgradePreCheck( tmpLoc )
	local x, features = pcall(require, "features")
	if x then
		if not features then
			if _G.DEVICE_TYPE and BASED_DEVICE_TYPE ~= _G.DEVICE_TYPE then
				return false, "device-type-error"
			end
			if _G.PRODUCT_ID and _G.PRODUCT_ID ~= BASED_PRODUCT_ID then
				return false, "device-type-error"
			end
		else
			if features.DEVICE_TYPE and BASED_DEVICE_TYPE ~= features.DEVICE_TYPE then
				return false, "device-type-error"
			end
			if features.PRODUCT_ID and features.PRODUCT_ID ~= BASED_PRODUCT_ID then
				return false, "device-type-error"
			end
		end
	end

	require "version"
	if SOFTWARE_VERSION then
		local n_bin_base=tonumber(BASED_VERSION_NUM)
		local n_bin_new=tonumber(NEW_VERSION_NUM)
		local n_dev_rev = SOFTWARE_VERSION:match("%x*%.%x*%.(.+)")
		n_dev_rev = tonumber(n_dev_rev)
		if n_bin_base and n_bin_new and n_dev_rev then
			if IS_DOWNGRADE then
				if n_bin_new >= n_dev_rev or n_bin_base < n_dev_rev then
					return false,"bin-base-version-is-higher"
				end
			else
				if n_bin_base > n_dev_rev then
					return false,"bin-base-version-is-higher"
				end
			end
		end
	end

	return true, "done"
end

return UpgradePreCheck

